#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    int8_t int8_eq_const_0_0;
    uint8_t uint8_eq_const_1_0;
    int32_t int32_eq_const_2_0;
    uint64_t uint64_eq_const_3_0;
    int8_t int8_eq_const_4_0;
    uint8_t uint8_eq_const_5_0;
    int16_t int16_eq_const_6_0;
    int16_t int16_eq_const_7_0;
    int32_t int32_eq_const_8_0;

    if (size < 24)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&int8_eq_const_0_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_1_0, &data[i], 1);
    i += 1;
    memcpy(&int32_eq_const_2_0, &data[i], 4);
    i += 4;
    memcpy(&uint64_eq_const_3_0, &data[i], 8);
    i += 8;
    memcpy(&int8_eq_const_4_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_5_0, &data[i], 1);
    i += 1;
    memcpy(&int16_eq_const_6_0, &data[i], 2);
    i += 2;
    memcpy(&int16_eq_const_7_0, &data[i], 2);
    i += 2;
    memcpy(&int32_eq_const_8_0, &data[i], 4);
    i += 4;


    if (int8_eq_const_0_0 == -113)
    if (uint8_eq_const_1_0 == 100)
    if (int32_eq_const_2_0 == -1846895033)
    if (uint64_eq_const_3_0 == 1853367645030652111u)
    if (int8_eq_const_4_0 == 106)
    if (uint8_eq_const_5_0 == 51)
    if (int16_eq_const_6_0 == 4128)
    if (int16_eq_const_7_0 == 4043)
    if (int32_eq_const_8_0 == -1802674352)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
